import * as z from './base';
import { ZodUndefined } from './undefined';
import { ZodNull } from './null';
import { ZodUnion } from './union';
export interface ZodStringDef extends z.ZodTypeDef {
    t: z.ZodTypes.string;
    validation: {
        uuid?: true;
        custom?: ((val: any) => boolean)[];
    };
}
export declare class ZodString extends z.ZodType<string, ZodStringDef> {
    optional: () => ZodUnion<[this, ZodUndefined]>;
    nullable: () => ZodUnion<[this, ZodNull]>;
    toJSON: () => ZodStringDef;
    min: (minLength: number, message?: string | {
        message?: string | undefined;
    } | undefined) => this;
    max: (maxLength: number, message?: string | {
        message?: string | undefined;
    } | undefined) => this;
    length: (len: number, message?: string | {
        message?: string | undefined;
    } | undefined) => this;
    email: (message?: string | {
        message?: string | undefined;
    } | undefined) => this;
    url: (message?: string | {
        message?: string | undefined;
    } | undefined) => this;
    uuid: (message?: string | {
        message?: string | undefined;
    } | undefined) => this;
    nonempty: (message?: string | {
        message?: string | undefined;
    } | undefined) => this;
    static create: () => ZodString;
}
